"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styles_1 = require("./styles");
const styled_components_1 = require("styled-components");
const Drawer = (props) => {
    const state = (0, react_usestateref_1.default)(false);
    const toggle = () => {
        state?.[1]?.(!state?.[0]);
    };
    const open = () => {
        state?.[1]?.(true);
    };
    const close = () => {
        state[1](false);
    };
    const passProps = (elements, toggleIndexes, openIndexes, closeIndexes, noClickIndexes) => {
        let grandchildren = react_1.default.Children.map(elements, (element) => {
            if (element.props?.children)
                return react_1.default.Children.map(element.props?.children, (grandchild) => grandchild);
        });
        console.log('grandchildren', grandchildren);
        grandchildren = grandchildren?.flat?.();
        console.log('grandchildren flat', grandchildren);
        return (grandchildren?.map?.(elements, (child, index) => {
            let find = toggleIndexes?.findIndex?.(openIndex => openIndex === index);
            let has = find !== null && find !== undefined && find > -1;
            let drawerAction = toggle;
            if (!has) {
                find = openIndexes?.findIndex?.(openIndex => openIndex === index);
                has = find !== null && find !== undefined && find > -1;
                drawerAction = open;
                if (!has) {
                    find = closeIndexes?.findIndex?.(closeIndex => closeIndex === index);
                    has = find !== null && find !== undefined && find > -1;
                    drawerAction = has ? close : undefined;
                }
            }
            find = noClickIndexes?.findIndex?.(openIndex => openIndex === index);
            has = find !== null && find !== undefined && find > -1;
            const newProps = {
                onClick: drawerAction,
                drawerAction: drawerAction,
                drawerState: state,
                drawerOpen: open,
                drawerClose: close,
                drawerToggle: toggle,
            };
            if (has)
                delete newProps.onClick;
            const cloneChild = react_1.default.cloneElement(child, newProps);
            return cloneChild;
        }));
    };
    const [children, setChildren] = (0, react_usestateref_1.default)(props.children ? (passProps(props.children, props.childrenToggleIndexes, props.childrenOpenIndexes, props.childrenCloseIndexes, props.childrenNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    const [navElements, setNavElements] = (0, react_usestateref_1.default)(props?.nav?.props?.children ? (passProps(props?.nav?.props?.children, props.navToggleIndexes, props.navOpenIndexes, props.navCloseIndexes, props.navNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    (0, react_1.useEffect)(() => {
        setChildren(props.children ? (passProps(props.children, props.childrenToggleIndexes, props.childrenOpenIndexes, props.childrenCloseIndexes, props.childrenNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
        setNavElements(props?.nav?.props?.children ? (passProps(props?.nav?.props?.children, props.navToggleIndexes, props.navOpenIndexes, props.navCloseIndexes, props.navNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    }, [props?.children, props?.nav?.props?.children, state?.[0]]);
    return (react_1.default.createElement(styles_1.DrawerWrapper, { className: state?.[0] ? 'openned' : 'closed', top: props.top },
        react_1.default.createElement(styles_1.DrawerHolder, { className: state?.[0] ? 'openned' : 'closed' }, navElements),
        react_1.default.createElement(styles_1.DrawerMenu, { className: state?.[0] ? 'openned' : 'closed', top: props.top }, children)));
};
exports.default = (0, styled_components_1.withTheme)(Drawer);
//# sourceMappingURL=index.js.map